Option Explicit

#include local-parameters.inc
#include ..\lib\framework_domotics.vbs

Sub main
Dim astrValue
Dim astrNbDv
Dim i
Dim astrDevices
Dim astrConfig
Dim atabDv
Dim astrFORMAT
Dim afloatUsed
Dim afloatFree
Dim astrBuffer
Dim astrParamMode
Dim astrNotifPoint
Dim atabNotifPoint
Dim aintWARNING
Dim aintCRITICAL
Dim aintSEVERE

on error resume next

WriteLog G_FOLDER_NAME, G_SCRIPT_EVT, G_TIV_INF, "Launching " & G_FOLDER_NAME & " script", G_LOG_FILE

If CheckDevices(G_FOLDER_NAME, G_FILE_INI, G_STATUS_EXIST) Then
		astrDevices 		= hs.GetINISetting("COMMON","DEVICES","", G_FILE_INI)
		astrConfig  		= hs.GetINISetting("COMMON","CONFIG","..\scripts\config\", G_FILE_INI)
		atabDv	 			= Split(astrDevices, G_SEP)
		astrNbDv 			= UBound(atabDv) 
		astrFORMAT 			= hs.GetINISetting("COMMON","FORMAT","",G_FILE_INI)
		
		If astrFORMAT <> "" Then
			i=0
			While (i <= Cint(astrNbDv))	
				astrValue 		= ""
				astrBuffer 		= hs.GetINISetting("DEVICE", "HC", "", astrConfig & atabDv(i)) & _ 
									hs.GetINISetting("DEVICE", "DC", "", astrConfig & atabDv(i))	
								
				astrParamMode 	= hs.GetINISetting("DEVICE", "PARAM1", "", astrConfig & atabDv(i))	
				astrNotifPoint  = hs.GetINISetting("DEVICE", "PARAM2", "", astrConfig & atabDv(i))
				
				atabNotifPoint  = Split(astrNotifPoint,G_SEP)
				
				WriteLog G_FOLDER_NAME, G_SCRIPT_EVT, G_TIV_INF, "PARAM2=" & astrNotifPoint & " for device. " & Ubound(atabNotifPoint)+1 & " levels are detected" & astrBuffer, G_LOG_FILE
				
				aintWARNING		= 0
				aintCRITICAL	= 0
				aintSEVERE		= 0
						
				If Ubound(atabNotifPoint) > 0 Then
					Dim j
					Dim atabBuff
					
					j = 0
					While (j <= Ubound(atabNotifPoint))
						atabBuff=Split(atabNotifPoint(j),G_COMMA)
						
						WriteLog G_FOLDER_NAME, G_SCRIPT_EVT, G_TIV_INF, astrBuffer & " has a " & atabBuff(0) & " level with " & atabBuff(1) & " as quota", G_LOG_FILE
						
						If Ubound(atabBuff) 	= 1 				Then
							If atabBuff(0) 		= G_TIV_WAR 		Then
								aintWARNING 	= Cint(atabBuff(1))
							Elseif atabBuff(0) 	= G_TIV_CRI 		Then
								aintCRITICAL 	= Cint(atabBuff(1))
							Elseif atabBuff(0) 	= G_TIV_SEV 		Then
								aintSEVERE 		= Cint(atabBuff(1))	
							Else
								WriteLog G_FOLDER_NAME, G_SCRIPT_EVT, G_TIV_CRI, astrBuffer & " has a PARAM2 problem : " & atabBuff(0), G_LOG_FILE	
							End if
						Else
							WriteLog G_FOLDER_NAME, G_SCRIPT_EVT, G_TIV_CRI, astrBuffer & " has a PARAM2 problem : " & atabNotifPoint(j), G_LOG_FILE	
						End if
						j=j+1
					Wend 
				Else
					WriteLog G_FOLDER_NAME, G_SCRIPT_EVT, G_TIV_WAR, astrBuffer & " has no quota !", G_LOG_FILE
				End if
				
				If (astrParamMode <> "") Then
					afloatUsed = CDbl(getUsedSpace(astrParamMode))
					afloatFree = CDbl(getFreeSpace(astrParamMode))
					
					If (afloatFree = -1) or (afloatUsed = -1) Then
						astrValue = ""
						
					Else
						astrValue  = replace(astrFormat, "##TOTAL##", afloatUsed)
						astrValue  = replace(astrValue,  "##USED##",  FormatNumber(afloatUsed - afloatFree, 2))							
						astrValue  = replace(astrValue,  "##FREE##",  afloatFree)							
						
					End if
				
					WriteLog G_FOLDER_NAME, G_SCRIPT_EVT, G_TIV_INF, astrValue & " is found", G_LOG_FILE
					SetDevice astrBuffer, astrValue, "", ""

					If (afloatFree *1000 <= aintSEVERE) Then
						WriteLog G_FOLDER_NAME, G_SCRIPT_EVT, G_TIV_SEV, astrBuffer & " is under the SEVERE quota " & Cstr(afloatFree *1000) & " <= " & Cstr (aintSEVERE), G_LOG_FILE
					ElseIf (afloatFree * 1000 <= aintCRITICAL) Then
						WriteLog G_FOLDER_NAME, G_SCRIPT_EVT, G_TIV_SEV, astrBuffer & " is under the CRITICAL quota " & Cstr(afloatFree *1000) & " <= " & Cstr (aintCRITICAL), G_LOG_FILE
					ElseIf (afloatFree *1000 <= aintWARNING) Then
						WriteLog G_FOLDER_NAME, G_SCRIPT_EVT, G_TIV_SEV, astrBuffer & " is under the WARNING quota " & Cstr(afloatFree *1000) & " <= " & Cstr (aintWARNING), G_LOG_FILE
					End if
					
				Else	
					WriteLog G_FOLDER_NAME, G_SCRIPT_EVT, G_TIV_CRI, "Param problems in [Module] section !", G_LOG_FILE		
					SetDevice astrBuffer, "???", "", ""	
				
				End if
				i=i+1
			Wend
			
		Else
			WriteLog G_FOLDER_NAME, G_SCRIPT_EVT, G_TIV_SEV, "Format is unknown !", G_LOG_FILE
		End if

Else
	WriteLog G_FOLDER_NAME, G_SCRIPT_EVT, G_TIV_SEV, "Expected Device is unknown !", G_LOG_FILE
	
End if

WriteLog G_FOLDER_NAME, G_SCRIPT_EVT, G_TIV_INF, "End of the script", G_LOG_FILE
End sub